'
' MiceSubs.Bas
' Use these subs to just pop right into your prog.
' See mice.txt for more info.
'

DEFINT A-Z


DECLARE SUB LimitRange (x1, y1, x2, y2)
DECLARE SUB LimitXRange (x1, x2)
DECLARE SUB LimitYRange (y1, y2)
DECLARE SUB MouseDriver (Ax, Bx, Cx, dx)
DECLARE SUB MouseHide ()
DECLARE SUB MouseLoad ()
DECLARE SUB MousePut (x, y)
DECLARE SUB MouseShow ()
DECLARE SUB MouseStatus (lb, rb, xMouse, yMouse)
DECLARE FUNCTION InRange (x1, y1, x2, y2)
DECLARE FUNCTION InXRange (x1, x2)
DECLARE FUNCTION InYRange (y1, y2)
DECLARE FUNCTION MouseInit ()

DIM SHARED Mouse$, lb, rb, x, y


MouseData:
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

persp! = .7
ang = 360 - 45

REDIM tmap(16, 16) AS STRING * 16
DIM showx(16, 16)
DIM showy(16, 16)
DIM mbuff(201)
DIM cop(16, 16)
DIM pal(512)

shxc = 80
shyc = 70

sx = shxc: sy = shyc
FOR y = 1 TO 16
FOR x = 1 TO 16
  showx(x, y) = sx
  showy(x, y) = sy
 sx = sx + 4
 sy = sy + 2
NEXT x
 sx = sx - (17 * 4)
 sy = sy - (15 * 2)
NEXT y


cpx = 270
cpy = 0

lx = 16: ly = 16: lz = 16
pp = 1
pcl = 0: pcr = 0

SCREEN 13



' You probably want DEFINT A-Z in your program.
' Add this to your dims: DIM Pal(512)
' Make sure nmedia.pal is in the directory,
' Then CALL SetupPalette.
' To Load a tile:
' DEF SEG = VARSEG(Array(0)): BLOAD  0 , VARPTR(Array(0))
' Important! Make sure that you DIM Array(201)!

DEF SEG = VARSEG(pal(0))
BLOAD "nmedia.pal", 0
i = 0
FOR c = 0 TO 255
 OUT &H3C8, c
 OUT &H3C9, PEEK(i)
 OUT &H3C9, PEEK(i + 1)
 OUT &H3C9, PEEK(i + 2)
 i = i + 4
NEXT c
DEF SEG






GET (1, 1)-(20, 20), mbuff

FOR y = 0 TO 31
FOR x = 0 TO 7
 LINE ((x * 5) + cpx, (y * 5) + cpy)-(((x + 1) * 5) + cpx, ((y + 1) * 5) + cpy), k, BF
 k = k + 1
NEXT x
NEXT y
LINE (cpx - 1, (32 * 5) + cpy - 1)-(cpx + (8 * 5) + 1, (38 * 5) + cpy + 1), 8, BF

drw = 1

CALL MouseLoad

DO

IF drw = 1 THEN
drw = 0

LINE (cpx, (32 * 5) + cpy)-(cpx + (8 * 5), (38 * 5) + cpy), pcl, BF
IF pcl = 0 THEN
LINE (cpx + 10, (32 * 5) + cpy + 20)-(cpx + (8 * 5) - 10, (38 * 5) + cpy - 20), 8, B
END IF

LINE (0, 0)-(260, 200), 0, BF

'Draw the 3D version
IF ddd = 1 THEN
 FOR y = 1 TO 16
 FOR x = 1 TO 16
              SELECT CASE ang
                CASE 0 TO 90
                 vx = (16 - x) + 1
                 vy = y
                CASE 90 TO 180
                 vx = (16 - x) + 1
                 vy = (16 - y) + 1
                CASE 180 TO 270
                 vx = x
                 vy = (16 - y) + 1
                CASE 270 TO 361
                 vx = x
                 vy = y
                END SELECT

  dx! = (vx - 8) * COS(ang * 3.141593 / 180) + (vy - 8) * SIN(ang * 3.141593 / 180)
  dy! = (vy - 8) * COS(ang * 3.141593 / 180) - (vx - 8) * SIN(ang * 3.141593 / 180)
  dx! = dx! + 200
  dy! = dy! + 70
 
  FOR z = 1 TO 16
     k = ASC(MID$(tmap(vx, vy), z, 1))
  IF k > 0 THEN
   fy! = dy! - (z - 8)
    fy! = fy! * persp!
    LINE (dx! * 3 - 400, fy! * 3 - 100)-(dx! * 3 - 398, fy! * 3 - 98), k, BF
   END IF
  NEXT z
 NEXT x
NEXT y


END IF

LINE (showx(1, 16), showy(1, 16) - ((lz / 2) * 8))-(showx(1, 1), showy(1, 1) - ((lz / 2) * 8)), 12
LINE (showx(16, 1), showy(16, 1) - ((lz / 2) * 8))-(showx(1, 1), showy(1, 1) - ((lz / 2) * 8)), 12

LINE (showx(lx, 16), showy(lx, 16) - ((1 / 2) * 8))-(showx(lx, 1), showy(lx, 1) - ((1 / 2) * 8)), 9
LINE (showx(lx, 1), showy(lx, 1) - ((16 / 2) * 8))-(showx(lx, 1), showy(lx, 1) - ((1 / 2) * 8)), 9

LINE (showx(16, ly), showy(16, ly) - ((1 / 2) * 8))-(showx(1, ly), showy(1, ly) - ((1 / 2) * 8)), 10
LINE (showx(1, ly), showy(1, ly) - ((16 / 2) * 8))-(showx(1, ly), showy(1, ly) - ((1 / 2) * 8)), 10


FOR y = 1 TO 16
FOR x = 1 TO 16
 FOR z = 1 TO 16
  tc = ASC(MID$(tmap(x, y), z, 1))
  IF tc > 0 THEN
LINE (showx(x, y) - 2, (showy(x, y) - ((z / 2) * 8)) - 2)-(showx(x, y) + 2, (showy(x, y) - ((z / 2 * 8)) + 2)), tc, BF
  END IF
 NEXT z
NEXT x
NEXT y


LINE (showx(1, 16), showy(1, 16) - ((lz / 2) * 8))-(showx(16, 16), showy(16, 16) - ((lz / 2) * 8)), 12
LINE (showx(16, 1), showy(16, 1) - ((lz / 2) * 8))-(showx(16, 16), showy(16, 16) - ((lz / 2) * 8)), 12

LINE (showx(lx, 16), showy(lx, 16) - ((1 / 2) * 8))-(showx(lx, 16), showy(lx, 16) - ((16 / 2) * 8)), 9
LINE (showx(lx, 16), showy(lx, 16) - ((16 / 2) * 8))-(showx(lx, 1), showy(lx, 1) - ((16 / 2) * 8)), 9

LINE (showx(16, ly), showy(16, ly) - ((1 / 2) * 8))-(showx(16, ly), showy(16, ly) - ((16 / 2) * 8)), 10
LINE (showx(16, ly), showy(16, ly) - ((16 / 2) * 8))-(showx(1, ly), showy(1, ly) - ((16 / 2) * 8)), 10

FOR y = 1 TO 16
FOR x = 1 TO 16
 
SELECT CASE pp
 CASE 1
  k = ASC(MID$(tmap(lx, 17 - x), 17 - y, 1))
 CASE 2
  k = ASC(MID$(tmap(x, ly), 17 - y, 1))
 CASE 3
  k = ASC(MID$(tmap(x, y), lz, 1))
END SELECT
IF mc = 1 THEN
 cop(x, y) = k
END IF

 IF k = 0 THEN
 LINE (((x - 1) * 7) + 145, ((y - 1) * 6) + 90)-((x * 7) + 145, (y * 6) + 90), 8, B
 PSET (((x * 7) + 145) - 3, ((y * 6) + 90) - 3), 8
ELSE
 LINE (((x - 1) * 7) + 145, ((y - 1) * 6) + 90)-((x * 7) + 145, (y * 6) + 90), k, BF
END IF
NEXT x
NEXT y

mc = 0
pc = 0




SELECT CASE pp
 CASE 1
  cz = 9
  cv = lx
 CASE 2
  cz = 10
  cv = ly
 CASE 3
  cz = 12
  cv = lz
END SELECT

LINE (0, 0)-(260, 199), cz, B
LINE (2, 2)-(21, 21), cz, B
COLOR cz
LOCATE 2, 23
PRINT "LAYER:"; cv
COLOR 9
LOCATE 23, 3
PRINT "X";
COLOR 10
PRINT " Y";
COLOR 12
PRINT " Z";
COLOR 15
PRINT " + -"


END IF

mdx = mx
mdy = my
 IF mdx > 299 THEN mdx = 299
 IF mdy > 179 THEN mdy = 179

PUT (mdx, mdy), mbuff, PSET

MouseStatus lb, rb, mx, my
mx = mx / 2
IF mx > (320 - 10) THEN mx = (320 - 10)
IF my > (200 - 10) THEN my = (200 - 10)
mdx = mx
mdy = my
 IF mdx > 299 THEN mdx = 299
 IF mdy > 179 THEN mdy = 179
GET (mdx, mdy)-(mdx + 19, mdy + 19), mbuff


bb = -1
IF my > 175 AND my < 185 THEN
 IF mx > 15 AND mx < 88 THEN
  bb = (mx) / 16
 END IF
END IF

 IF my > 89 AND my < 187 THEN
  IF mx > 144 AND my < 258 THEN
   dmx = (mx - 142) / 7
   dmy = (my - 87) / 6
  END IF
  END IF

'COLOR 15
'LOCATE 1, 1
'PRINT "MX:"; mx
'PRINT "MY:"; my
'PRINT "DMX:"; dmx
'PRINT "DMY:"; dmy
'PRINT bb



IF lb = -1 THEN
 IF my > 89 AND my < 187 THEN
  IF mx > 144 AND my < 258 THEN
   dmx = (mx - 142) / 7
   dmy = (my - 87) / 6
 
'**************************************************************************
' dmy = 17 - dmy
IF dmx >= 1 AND dmx <= 16 AND dmy >= 1 AND dmy <= 16 THEN

SELECT CASE pp
 CASE 1
tmap(lx, 17 - dmx) = MID$(tmap(lx, 17 - dmx), 1, (17 - dmy) - 1) + CHR$(pcl) + MID$(tmap(lx, 17 - dmx), (17 - dmy) + 1, 16)
  'k = ASC(MID$(tmap(lx, x), y, 1))
 CASE 2
tmap(dmx, ly) = MID$(tmap(dmx, ly), 1, (17 - dmy) - 1) + CHR$(pcl) + MID$(tmap(dmx, ly), (17 - dmy) + 1, 16)
  'k = ASC(MID$(tmap(x, ly), y, 1))
 CASE 3
tmap(dmx, dmy) = MID$(tmap(dmx, dmy), 1, lz - 1) + CHR$(pcl) + MID$(tmap(dmx, dmy), lz + 1, 16)
  'k = ASC(MID$(tmap(x, y), lz, 1))
END SELECT
drw = 1
   
END IF
 
  END IF
  END IF

 IF mx > 269 AND my < 159 THEN
  pcl = POINT(mx, my): drw = 1
 END IF

 SELECT CASE bb
  CASE 1
   pp = 1: drw = 1
  CASE 2
   pp = 2: drw = 1
  CASE 3
   pp = 3: drw = 1
  CASE 4
SELECT CASE pp
 CASE 1
  lx = lx + 1
  IF lx > 16 THEN lx = 1
   drw = 1
 CASE 2
  ly = ly + 1
  IF ly > 16 THEN ly = 1
   drw = 1
 CASE 3
  lz = lz + 1
  IF lz > 16 THEN lz = 1
   drw = 1
END SELECT
  CASE 5
SELECT CASE pp
 CASE 1
  lx = lx - 1
  IF lx < 1 THEN lx = 16
   drw = 1
 CASE 2
  ly = ly - 1
  IF ly < 1 THEN ly = 16
   drw = 1
 CASE 3
  lz = lz - 1
  IF lz < 1 THEN lz = 16
   drw = 1
END SELECT
END SELECT
END IF

LINE (mx, my)-(mx + 8, my), 15
LINE (mx, my)-(mx, my + 8), 15
LINE (mx + 8, my)-(mx, my + 8), 15



FOR y = 1 TO 16
FOR x = 1 TO 16
 PSET (x + 3, y + 3), cop(x, y)
NEXT x
NEXT y


WAIT &H3DA, 8
SELECT CASE INKEY$
 CASE ",", "<"
  ang = ang + 15
  drw = 1
  IF ang > 360 THEN ang = ang - 360
 CASE ".", ">"
  ang = ang - 15
  drw = 1
  IF ang < 0 THEN ang = ang + 360
 CASE "d", "D"
  ddd = 1 - ddd: drw = 1
 CASE "s", "S"
  drw = 1
   COLOR 15
   LOCATE 1, 1
    PRINT "SAVE TMAP AS [NO EXT] =>";
    INPUT nam$
   nam$ = nam$ + ".TMP"
    OPEN nam$ FOR OUTPUT AS #1
     FOR y = 1 TO 16
     FOR x = 1 TO 16
      FOR z = 1 TO 16
       v = ASC(MID$(tmap(x, y), z, 1))
      PRINT #1, v
      NEXT z
      NEXT x
     NEXT y
    CLOSE #1
 CASE "l", "L"
  drw = 1
   COLOR 15
   LOCATE 1, 1
    PRINT "LOAD TMAP [NO EXT] =>";
    INPUT nam$
 REDIM tmap(16, 16) AS STRING * 16
   nam$ = nam$ + ".TMP"
    OPEN nam$ FOR INPUT AS #1
     FOR y = 1 TO 16
     FOR x = 1 TO 16
      FOR z = 1 TO 16
       INPUT #1, v
      tmap(x, y) = MID$(tmap(x, y), 1, z - 1) + CHR$(v)
      NEXT z
     NEXT x
     NEXT y
    CLOSE #1
  CASE "n", "N"
   drw = 1
    COLOR 15
    LOCATE 1, 1
     PRINT "<NEW TMAP> ARE YOU SHURE (Y/N)?"
       ans = 0
      DO
       IF INKEY$ = "y" OR INKEY$ = "Y" THEN ans = 1
       IF INKEY$ = "n" OR INKEY$ = "N" THEN ans = 2
      LOOP UNTIL ans > 0
       IF ans = 1 THEN
        REDIM tmap(16, 16) AS STRING * 16

       END IF
 CASE "p", "P"
  FOR y = 1 TO 16
  FOR x = 1 TO 16
SELECT CASE pp
 CASE 1
tmap(lx, 17 - x) = MID$(tmap(lx, 17 - x), 1, (17 - y) - 1) + CHR$(cop(x, y)) + MID$(tmap(lx, 17 - x), (17 - y) + 1, 16)
CASE 2
tmap(x, ly) = MID$(tmap(x, ly), 1, (17 - y) - 1) + CHR$(cop(x, y)) + MID$(tmap(x, ly), (17 - y) + 1, 16)
CASE 3
tmap(x, y) = MID$(tmap(x, y), 1, lz - 1) + CHR$(cop(x, y)) + MID$(tmap(x, y), lz + 1, 16)
END SELECT
  NEXT x
  NEXT y
drw = 1
  
 CASE "c", "C"
  mc = 1: drw = 1

 CASE CHR$(27)
  quit = 1

 CASE "-", "_"
SELECT CASE pp
 CASE 1
  lx = lx - 1
  IF lx < 1 THEN lx = 16
   drw = 1
 CASE 2
  ly = ly - 1
  IF ly < 1 THEN ly = 16
   drw = 1
 CASE 3
  lz = lz - 1
  IF lz < 1 THEN lz = 16
   drw = 1
END SELECT
 CASE "=", "+"
SELECT CASE pp
 CASE 1
  lx = lx + 1
  IF lx > 16 THEN lx = 1
   drw = 1
 CASE 2
  ly = ly + 1
  IF ly > 16 THEN ly = 1
   drw = 1
 CASE 3
  lz = lz + 1
  IF lz > 16 THEN lz = 1
   drw = 1
END SELECT
 CASE "x", "X"
  pp = 1: drw = 1
 CASE "y", "Y"
  pp = 2: drw = 1
 CASE "z", "Z"
  pp = 3: drw = 1

 CASE "f", "F"
  FOR y = 1 TO 16
  FOR x = 1 TO 16
SELECT CASE pp
 CASE 1
tmap(lx, 17 - x) = MID$(tmap(lx, 17 - x), 1, (17 - y) - 1) + CHR$(pcl) + MID$(tmap(lx, 17 - x), (17 - y) + 1, 16)
CASE 2
tmap(x, ly) = MID$(tmap(x, ly), 1, (17 - y) - 1) + CHR$(pcl) + MID$(tmap(x, ly), (17 - y) + 1, 16)
CASE 3
tmap(x, y) = MID$(tmap(x, y), 1, lz - 1) + CHR$(pcl) + MID$(tmap(x, y), lz + 1, 16)
END SELECT
  NEXT x
  NEXT y
drw = 1
 




END SELECT
LOOP UNTIL quit = 1
COLOR 15

FUNCTION InRange (x1, y1, x2, y2)

IF x / 2 >= x1 AND y >= y1 AND x / 2 <= x2 AND y <= y2 THEN InRange = -1

END FUNCTION

FUNCTION InXRange (x1, x2)

IF (x / 2) >= x1 AND (x / 2) <= x2 THEN InXRange = -1

END FUNCTION

FUNCTION InYRange (y1, y2)

IF y >= y1 AND y <= y2 THEN InYRange = -1

END FUNCTION

SUB LimitRange (x1, y1, x2, y2)
 
Ax = 7
Cx = x1 * 2
dx = x2 * 2
MouseDriver Ax, 0, Cx, dx
Ax = 8
Cx = y1
dx = y2
MouseDriver Ax, 0, Cx, dx

END SUB

SUB LimitXRange (x1, x2)

Ax = 7
Cx = x1 * 2
dx = x2 * 2
MouseDriver Ax, 0, Cx, dx
Ax = 8
Cx = 0
dx = 200
MouseDriver Ax, 0, Cx, dx

END SUB

SUB LimitYRange (y1, y2)

Ax = 7
Cx = 0
dx = 640
MouseDriver Ax, 0, Cx, dx
Ax = 8
Cx = y1
dx = y2
MouseDriver Ax, 0, Cx, dx

END SUB

SUB MouseDriver (Ax, Bx, Cx, dx)
 
DEF SEG = VARSEG(Mouse$)
Mouse = SADD(Mouse$)
CALL Absolute(Ax, Bx, Cx, dx, Mouse)

END SUB

SUB MouseHide

Ax = 2
MouseDriver Ax, 0, 0, 0

END SUB

FUNCTION MouseInit
 
Ax = 0
MouseDriver Ax, 0, 0, 0
MouseInit = Ax

END FUNCTION

SUB MouseLoad

Mouse$ = SPACE$(57)

RESTORE MouseData

FOR i = 1 TO 57
 READ a$
 H$ = CHR$(VAL("&H" + a$))
 MID$(Mouse$, i, 1) = H$
NEXT i

IF NOT MouseInit THEN
 PRINT "Mouse not found."
 END
END IF

CALL LimitRange(0, 0, 319, 199)

END SUB

SUB MousePut (x, y)
 
Ax = 4
Cx = x * 2
dx = y
MouseDriver Ax, 0, Cx, dx

END SUB

SUB MouseShow
 
Ax = 1
MouseDriver Ax, 0, 0, 0

END SUB

SUB MouseStatus (lb, rb, xMouse, yMouse)
 
Ax = 3
MouseDriver Ax, Bx, Cx, dx
lb = ((Bx AND 1) <> 0)
rb = ((Bx AND 2) <> 0)
xMouse = Cx
yMouse = dx

END SUB

